import{s as Ee,n as ke,o as ze}from"../chunks/scheduler.22bf70d2.js";import{S as Oe,i as Ie,g as l,s as n,r as m,A as Ve,h as o,f as t,c as s,j as c,u as p,x as L,k as g,y as i,a as r,v as u,d,t as _,w as v}from"../chunks/index.59178e06.js";import{D}from"../chunks/Docstring.2181bae0.js";import{H as qe,E as Ae}from"../chunks/EditOnGithub.86314611.js";function Ge(we){let f,K,R,Q,C,W,h,T,_e,q,Me=`Plugin for Megatron-LM to enable tensor, pipeline, sequence and data parallelism. Also to enable selective
activation recomputation and optimized fused kernels.`,X,b,P,ve,A,Ne=`Dummy scheduler presents model parameters or param groups, this is primarily used to follow conventional training
loop when scheduler config is specified in the deepspeed config file.`,Y,$,S,fe,G,Le="Dummy dataloader presents model parameters or param groups, this is primarily used to follow conventional training",Z,x,E,he,B,De="Abstract class for batching, forward pass and loss handler.",ee,y,k,be,F,Ce="GPT train step class.",te,w,z,$e,U,Te="Bert train step class.",ae,M,O,xe,j,Pe="T5 train step class.",re,N,I,ye,H,Se="Average losses across data parallel group.",ne,V,se,J,le;return C=new qe({props:{title:"Utilities for Megatron-LM",local:"accelerate.utils.MegatronLMPlugin",headingTag:"h1"}}),T=new D({props:{name:"class accelerate.utils.MegatronLMPlugin",anchor:"accelerate.utils.MegatronLMPlugin",parameters:[{name:"tp_degree",val:": int = None"},{name:"pp_degree",val:": int = None"},{name:"num_micro_batches",val:": int = None"},{name:"gradient_clipping",val:": float = None"},{name:"sequence_parallelism",val:": bool = None"},{name:"recompute_activations",val:": bool = None"},{name:"use_distributed_optimizer",val:": bool = None"},{name:"pipeline_model_parallel_split_rank",val:": int = None"},{name:"num_layers_per_virtual_pipeline_stage",val:": int = None"},{name:"is_train_batch_min",val:": str = True"},{name:"train_iters",val:": int = None"},{name:"train_samples",val:": int = None"},{name:"weight_decay_incr_style",val:": str = 'constant'"},{name:"start_weight_decay",val:": float = None"},{name:"end_weight_decay",val:": float = None"},{name:"lr_decay_style",val:": str = 'linear'"},{name:"lr_decay_iters",val:": int = None"},{name:"lr_decay_samples",val:": int = None"},{name:"lr_warmup_iters",val:": int = None"},{name:"lr_warmup_samples",val:": int = None"},{name:"lr_warmup_fraction",val:": float = None"},{name:"min_lr",val:": float = 0"},{name:"consumed_samples",val:": List = None"},{name:"no_wd_decay_cond",val:": Optional = None"},{name:"scale_lr_cond",val:": Optional = None"},{name:"lr_mult",val:": float = 1.0"},{name:"megatron_dataset_flag",val:": bool = False"},{name:"seq_length",val:": int = None"},{name:"encoder_seq_length",val:": int = None"},{name:"decoder_seq_length",val:": int = None"},{name:"tensorboard_dir",val:": str = None"},{name:"set_all_logging_options",val:": bool = False"},{name:"eval_iters",val:": int = 100"},{name:"eval_interval",val:": int = 1000"},{name:"return_logits",val:": bool = False"},{name:"custom_train_step_class",val:": Optional = None"},{name:"custom_train_step_kwargs",val:": Optional = None"},{name:"custom_model_provider_function",val:": Optional = None"},{name:"custom_prepare_model_function",val:": Optional = None"},{name:"other_megatron_args",val:": Optional = None"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/dataclasses.py#L1235"}}),P=new D({props:{name:"class accelerate.utils.MegatronLMDummyScheduler",anchor:"accelerate.utils.MegatronLMDummyScheduler",parameters:[{name:"optimizer",val:""},{name:"total_num_steps",val:" = None"},{name:"warmup_num_steps",val:" = 0"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"accelerate.utils.MegatronLMDummyScheduler.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.optimizer.Optimizer</code>) &#x2014;
The optimizer to wrap.`,name:"optimizer"},{anchor:"accelerate.utils.MegatronLMDummyScheduler.total_num_steps",description:`<strong>total_num_steps</strong> (int) &#x2014;
Total number of steps.`,name:"total_num_steps"},{anchor:"accelerate.utils.MegatronLMDummyScheduler.warmup_num_steps",description:`<strong>warmup_num_steps</strong> (int) &#x2014;
Number of steps for warmup.`,name:"warmup_num_steps"},{anchor:"accelerate.utils.MegatronLMDummyScheduler.*kwargs",description:`*<strong>*kwargs</strong> (additional keyword arguments, <em>optional</em>) &#x2014;
Other arguments.`,name:"*kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L413"}}),S=new D({props:{name:"class accelerate.utils.MegatronLMDummyDataLoader",anchor:"accelerate.utils.MegatronLMDummyDataLoader",parameters:[{name:"**dataset_kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L144"}}),E=new D({props:{name:"class accelerate.utils.AbstractTrainStep",anchor:"accelerate.utils.AbstractTrainStep",parameters:[{name:"name",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L450"}}),k=new D({props:{name:"class accelerate.utils.GPTTrainStep",anchor:"accelerate.utils.GPTTrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.GPTTrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L596"}}),z=new D({props:{name:"class accelerate.utils.BertTrainStep",anchor:"accelerate.utils.BertTrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.BertTrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L467"}}),O=new D({props:{name:"class accelerate.utils.T5TrainStep",anchor:"accelerate.utils.T5TrainStep",parameters:[{name:"args",val:""}],parametersDescription:[{anchor:"accelerate.utils.T5TrainStep.args",description:"<strong>args</strong> (<code>argparse.Namespace</code>) &#x2014; Megatron-LM arguments.",name:"args"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L702"}}),I=new D({props:{name:"accelerate.utils.avg_losses_across_data_parallel_group",anchor:"accelerate.utils.avg_losses_across_data_parallel_group",parameters:[{name:"losses",val:""}],parametersDescription:[{anchor:"accelerate.utils.avg_losses_across_data_parallel_group.losses",description:"<strong>losses</strong> (List[Tensor]) &#x2014; List of losses to average across data parallel group.",name:"losses"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/utils/megatron_lm.py#L1404"}}),V=new Ae({props:{source:"https://github.com/huggingface/accelerate/blob/main/docs/source/package_reference/megatron_lm.md"}}),{c(){f=l("meta"),K=n(),R=l("p"),Q=n(),m(C.$$.fragment),W=n(),h=l("div"),m(T.$$.fragment),_e=n(),q=l("p"),q.textContent=Me,X=n(),b=l("div"),m(P.$$.fragment),ve=n(),A=l("p"),A.textContent=Ne,Y=n(),$=l("div"),m(S.$$.fragment),fe=n(),G=l("p"),G.textContent=Le,Z=n(),x=l("div"),m(E.$$.fragment),he=n(),B=l("p"),B.textContent=De,ee=n(),y=l("div"),m(k.$$.fragment),be=n(),F=l("p"),F.textContent=Ce,te=n(),w=l("div"),m(z.$$.fragment),$e=n(),U=l("p"),U.textContent=Te,ae=n(),M=l("div"),m(O.$$.fragment),xe=n(),j=l("p"),j.textContent=Pe,re=n(),N=l("div"),m(I.$$.fragment),ye=n(),H=l("p"),H.textContent=Se,ne=n(),m(V.$$.fragment),se=n(),J=l("p"),this.h()},l(e){const a=Ve("svelte-u9bgzb",document.head);f=o(a,"META",{name:!0,content:!0}),a.forEach(t),K=s(e),R=o(e,"P",{}),c(R).forEach(t),Q=s(e),p(C.$$.fragment,e),W=s(e),h=o(e,"DIV",{class:!0});var oe=c(h);p(T.$$.fragment,oe),_e=s(oe),q=o(oe,"P",{"data-svelte-h":!0}),L(q)!=="svelte-51ubws"&&(q.textContent=Me),oe.forEach(t),X=s(e),b=o(e,"DIV",{class:!0});var ie=c(b);p(P.$$.fragment,ie),ve=s(ie),A=o(ie,"P",{"data-svelte-h":!0}),L(A)!=="svelte-mxz6g6"&&(A.textContent=Ne),ie.forEach(t),Y=s(e),$=o(e,"DIV",{class:!0});var me=c($);p(S.$$.fragment,me),fe=s(me),G=o(me,"P",{"data-svelte-h":!0}),L(G)!=="svelte-1r57fhg"&&(G.textContent=Le),me.forEach(t),Z=s(e),x=o(e,"DIV",{class:!0});var ce=c(x);p(E.$$.fragment,ce),he=s(ce),B=o(ce,"P",{"data-svelte-h":!0}),L(B)!=="svelte-7ith7r"&&(B.textContent=De),ce.forEach(t),ee=s(e),y=o(e,"DIV",{class:!0});var pe=c(y);p(k.$$.fragment,pe),be=s(pe),F=o(pe,"P",{"data-svelte-h":!0}),L(F)!=="svelte-8o1bfn"&&(F.textContent=Ce),pe.forEach(t),te=s(e),w=o(e,"DIV",{class:!0});var ge=c(w);p(z.$$.fragment,ge),$e=s(ge),U=o(ge,"P",{"data-svelte-h":!0}),L(U)!=="svelte-1af56j7"&&(U.textContent=Te),ge.forEach(t),ae=s(e),M=o(e,"DIV",{class:!0});var ue=c(M);p(O.$$.fragment,ue),xe=s(ue),j=o(ue,"P",{"data-svelte-h":!0}),L(j)!=="svelte-1w9r8gv"&&(j.textContent=Pe),ue.forEach(t),re=s(e),N=o(e,"DIV",{class:!0});var de=c(N);p(I.$$.fragment,de),ye=s(de),H=o(de,"P",{"data-svelte-h":!0}),L(H)!=="svelte-39hqbl"&&(H.textContent=Se),de.forEach(t),ne=s(e),p(V.$$.fragment,e),se=s(e),J=o(e,"P",{}),c(J).forEach(t),this.h()},h(){g(f,"name","hf:doc:metadata"),g(f,"content",Be),g(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),g(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,a){i(document.head,f),r(e,K,a),r(e,R,a),r(e,Q,a),u(C,e,a),r(e,W,a),r(e,h,a),u(T,h,null),i(h,_e),i(h,q),r(e,X,a),r(e,b,a),u(P,b,null),i(b,ve),i(b,A),r(e,Y,a),r(e,$,a),u(S,$,null),i($,fe),i($,G),r(e,Z,a),r(e,x,a),u(E,x,null),i(x,he),i(x,B),r(e,ee,a),r(e,y,a),u(k,y,null),i(y,be),i(y,F),r(e,te,a),r(e,w,a),u(z,w,null),i(w,$e),i(w,U),r(e,ae,a),r(e,M,a),u(O,M,null),i(M,xe),i(M,j),r(e,re,a),r(e,N,a),u(I,N,null),i(N,ye),i(N,H),r(e,ne,a),u(V,e,a),r(e,se,a),r(e,J,a),le=!0},p:ke,i(e){le||(d(C.$$.fragment,e),d(T.$$.fragment,e),d(P.$$.fragment,e),d(S.$$.fragment,e),d(E.$$.fragment,e),d(k.$$.fragment,e),d(z.$$.fragment,e),d(O.$$.fragment,e),d(I.$$.fragment,e),d(V.$$.fragment,e),le=!0)},o(e){_(C.$$.fragment,e),_(T.$$.fragment,e),_(P.$$.fragment,e),_(S.$$.fragment,e),_(E.$$.fragment,e),_(k.$$.fragment,e),_(z.$$.fragment,e),_(O.$$.fragment,e),_(I.$$.fragment,e),_(V.$$.fragment,e),le=!1},d(e){e&&(t(K),t(R),t(Q),t(W),t(h),t(X),t(b),t(Y),t($),t(Z),t(x),t(ee),t(y),t(te),t(w),t(ae),t(M),t(re),t(N),t(ne),t(se),t(J)),t(f),v(C,e),v(T),v(P),v(S),v(E),v(k),v(z),v(O),v(I),v(V,e)}}}const Be='{"title":"Utilities for Megatron-LM","local":"accelerate.utils.MegatronLMPlugin","sections":[],"depth":1}';function Fe(we){return ze(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Je extends Oe{constructor(f){super(),Ie(this,f,Fe,Ge,Ee,{})}}export{Je as component};
